import Flutter
import UIKit
import TeachmintSdk
import SwiftUI

public class SwiftFlutterTeachstackSdkPlugin: UIView, FlutterPlugin{

    
    public static func register(with registrar: FlutterPluginRegistrar) {
        let channel = FlutterMethodChannel(name: "flutter_teachstack_sdk", binaryMessenger: registrar.messenger())
        let instance = SwiftFlutterTeachstackSdkPlugin()
        registrar.addMethodCallDelegate(instance, channel: channel)
    }
    
    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        if(call.method.elementsEqual("liveClass")) {
            let arguments = call.arguments as? NSDictionary
            guard let url = arguments?["url"] as? String else {return}
            let yourAppGroupName = arguments?["yourAppGroupName"] as? String
            addSubview(MyViewController(data:(url,yourAppGroupName)).view)
        }
    }
    
   
}


class MyViewController:UIViewController,TeachmintRoomViewDelegate{
    var myWindow:UIWindow?
    var myView:UIView?
    var data:(String,String?) = ("",nil)
    
    
    init(data:(String,String?) = ("",nil)){
        self.data = data
        super.init(nibName: nil, bundle: nil)
    }
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    override func viewDidLoad() {
        //myWindow = UIApplication.shared.windows.filter {$0.isKeyWindow}.first
        let view =  TMEvaasBuilder(delegate: self,
                                   suiteName: data.1,
                                   url: data.0,
                                   language: "en",
                                   host: "api.teachmint.com")
        let c = UIHostingController(rootView: view)
        myWindow = UIWindow(frame: UIScreen.main.bounds )
        c.view.frame = UIScreen.main.bounds
        myWindow?.rootViewController = c
        myView = c.view
        myWindow?.makeKeyAndVisible()
    }
    override func viewWillLayoutSubviews() {
        myView?.frame = UIScreen.main.bounds
    }
    
    public func onMeetingEnded(reason: String, recording: Bool, study_material: Bool, session_id: String?) {
        myView?.removeFromSuperview()
    }
    
    public func trackEvent(eventName: String, eventData: [String : String]) {
        
    }
    
}
